package xyz.tbvns.GeometryDash;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g3d.Material;
import com.badlogic.gdx.graphics.g3d.Model;
import com.badlogic.gdx.graphics.g3d.ModelCache;
import com.badlogic.gdx.graphics.g3d.ModelInstance;
import com.badlogic.gdx.graphics.g3d.attributes.ColorAttribute;
import com.badlogic.gdx.graphics.g3d.utils.ModelBuilder;
import xyz.tbvns.Objects.Level;
import xyz.tbvns.Objects.Object;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class LevelUtils {
    private static List<Model> models = new ArrayList<>();
    private static ModelCache modelCache = new ModelCache();

    public static ModelCache generateModelCache(Level level) throws IOException {
        modelCache.dispose();
        for (Model model : models) {
            model.dispose();
        }
        models.clear();
        modelCache = new ModelCache();
        modelCache.begin();
        for (Object object : Object.fromLevel(level)) {
            Model model =new ModelBuilder().createRect(
                    0f, 0f, 0f,
                    1f, 0f, 0f,
                    1f, 1f, 0f,
                    0, 1, 0f,
                    0, 0, 0,
                    new Material(ColorAttribute.createDiffuse(new Color(0, 0, new Random().nextFloat(0, 1), 0))), 1
            );
            models.add(model);
            modelCache.add(new ModelInstance(model, Float.parseFloat(object.getProperties().get("2")) / 30, Float.parseFloat(object.getProperties().get("3")) / 30, 0));
        }
        modelCache.end();
        return modelCache;
    }
}
